//
//  AppUtils.h
//  Piccer
//
//  Created by EbitM07 on 12/26/16.
//  Copyright © 2016 EbitM07. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "UserPrivacy.h"
#import "UserNotification.h"
#import "UserProfile.h"

@interface AppUtils : NSObject

typedef enum {
    RegSvr,
    CmpSvr,
} Phase;

typedef enum {
    Started,
    RegSent,
    Registered,
    GetResSent,
    LogSent,
    Logged,
    DeregSent
} State;

@property UserProfile *loginUserProfile;

+(NSArray *)aryCategory;

+(NSData *)dataX_Key16;
+(NSData *)dataY_Key16;
+(NSData *)dataZ_Key16;
+(NSData *)dataK_Key16;


+(NSString *)getJsonFormatedStringFromDictionary:(NSDictionary *)dicData;

+(void)postUrlCall:(NSString *)strURL Parameter:(NSDictionary*) dicParameter handler:(void (^)(BOOL isSuccess, NSDictionary *dicData, NSString *strMessage))finishBlock;
+(void)getUrlCall:(NSString *)strURL Parameter:(NSDictionary*) dicParameter handler:(void (^)(BOOL isSuccess, NSDictionary *dicData, NSString *strMessage))finishBlock;
+(NSString *)convertNSDateToString:(NSDate *)date Format:(NSString *)format;
+(NSDate *)convertStringToNSDate:(NSString *)strDate Format:(NSString *)format;
+(void)ShowAlert:(NSString *) message FromVC:(UIViewController*)selfVC Completion: (void (^)(UIAlertAction *)) callbackBlock;

+(NSString *)GetEmail;
+(void)SetEmail:(NSString *)email;
+(NSString *)GetPassword;
+(void)SetPassword:(NSString *)password;
+(NSString *)GetUserId;
+(void)SetUserId:(NSString *)userId;
+(NSString *)GetCampusd;
+(void)SetCampusId:(NSString *)campusId;
+(NSString *)GetCampSrvIp;
+(void)SetCampSrvIp:(NSString *)campSrvIp;
+(NSString *)GetCampSrvPort;
+(void)SetCampSrvPort:(NSString *)campSrvPort;
+(NSString *)GetPhase;
+(void)SetPhase:(NSString *)phase;
+(NSString *)GetAutoLoginStatus;
+(void)SetAutoLoginStatus:(NSString *)status;
+(NSString *)GetIsLoggedIn;
+(void)SetIsLoggedIn:(NSString *)status;
+(NSString *)getGCMID;
+(void)SetGCMID:(NSString *)gcmid;
+(NSString *)getSchoolCampus;
+(void)SetSchoolCampus:(NSString *)schoolCampus;
+(UserPrivacy *)getUserPrivacySetting;
+(void)saveUserPrivacySetting:(UserPrivacy *)object;
+(UserNotification *)getUserNotificationSetting;
+(void)saveUserNotificationSetting:(UserNotification *)object;
+(NSString *)getSelectedCategory;
+(void)SetSelectedCategory:(NSString *)selectedCategory;
+(BOOL)GetOnCampusSharing;
+(void)SetOnCampusSharing:(BOOL)status;
+(BOOL)GetShowPublicHangout;
+(void)SetShowPublicHangout:(BOOL)show;
+(BOOL)GetIsInGeofence;
+(void)SetIsInGeofence:(BOOL)isInGeofence;
+(NSString *)getGlobalVersion;
+(void)SetGlobalVersion:(NSString *)globalVersion;
+(NSDictionary *)getCampSvrConf;
+(void)SetCampSvrConf:(NSDictionary *)dicData;
+(NSString *)getInterstitialAdHour;
+(void)setInterstitialAdHour:(NSString *)hour;
+(BOOL)getDisplayAd;
+(void)SetDisplayAd:(BOOL)display;


+(NSString*)remaningTime:(NSDate*)startDate endDate:(NSDate*)endDate;

+(NSData *) XORBytesWithData1:(NSData *) data1 Data2:(NSData *)data2;
+(BOOL) IsValidEmail:(NSString *)checkString;
+(UIImage *)scaleImage:(UIImage *)image toSize:(CGSize)newSize;
+(CGFloat)getLabelHeight:(UILabel*)label;
+(int) convertToNewDateFormate:(NSDate *)date;
+(NSDate *) convertFromNewDateFormate:(int)intDate;
+(void) displayInterstitialAd;
+(void)sendScreenTracker:(NSString *)screenName;
+(void)sendEventTrackerWithAction:(NSString *)action;


// Hash function
+(int)getHashString:(NSString *)data;
+(int)getHashInt:(int) data;
+(int)getHashBool:(int) data;
+(float)trimDoubleAfterDecimalPoint:(int)floatingDigit DoubleValue:(double)value;
+(void)displayLocalNotification:(NSString *)strAlertBody;


@end
